<template>
  <button class="btn btn-sm mb-1 mr-1" :class="color" :disabled="disabled" @click="select">
    {{ label }}
  </button>
</template>
<script>
import { differenceInDays, lightFormat } from "date-fns";
import { parseISO } from "date-fns/fp";
export default {
  props: {
    session: {},
    register: { type: Number, default: 0 },
    selected: { type: Boolean, default: false }
  },
  computed: {
    start() {
      return parseISO(this.session.start);
    },
    end() {
      return parseISO(this.session.end);
    },
    label() {
      if (differenceInDays(this.end, this.start) > 0) {
        return `${lightFormat(this.start, "yyyy-MM-dd HH:mm")} - ${lightFormat(
          this.end,
          "yyyy-MM-dd HH:mm"
        )}`;
      } else {
        return lightFormat(this.start, "HH:mm");
      }
    },
    color() {
      if (this.selected) {
        return "btn-success";
      }
      if (this.session.registration.current >= this.session.registration.max) {
        return "btn-danger";
      }

      if (this.session.registration.current <= 0) {
        return "btn-primary";
      }

      return "btn-warning";
    },
    disabled() {
      const registration = this.session.registration;
      return registration.max - registration.current - this.register < 0;
    }
  },
  methods: {
    select() {
      this.$emit("select");
    }
  }
};
</script>